import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;


public class ActionsAtRound extends Hashtable<Integer, Vector<Actions>>{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public ActionsAtRound(){}
	
	public ActionsAtRound(ActionsAtRound aar){
		Iterator<Integer> it = aar.keySet().iterator();
		Iterator<Actions> it_act;
		Integer round;
		Actions acts;
		Vector<Actions> acts_at_round;
		while(it.hasNext()){
			round=it.next();
			acts_at_round=new Vector<Actions>();
			it_act=aar.get(round).iterator();
			while(it_act.hasNext()){
				acts=new Actions(it_act.next());
				acts_at_round.add(acts);
			}			
			this.put(round, acts_at_round);
		}
	}
	
	public void addRoundActions(Integer round, Actions actions_r){
		if(this.containsKey(round)){
			this.get(round).add(actions_r);
		}else{
			Vector<Actions> actions=new Vector<Actions>();
			actions.add(actions_r);
			this.put(round, actions);
		}
	}
}
