import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;


public class GoalsAtPriority extends Hashtable<Integer, Vector<String>>{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	public void addPriorityGoals(Integer prio, String goals_p){
		if(this.containsKey(prio)){
			this.get(prio).add(goals_p);
		}else{
			Vector<String> goals=new Vector<String>();
			goals.add(goals_p);
			this.put(prio, goals);
		}
	}
	public GoalsAtPriority(){}
	
	public GoalsAtPriority(GoalsAtPriority gap){
		Iterator<Integer> it = gap.keySet().iterator();
		Iterator<String> it_goal;
		Integer prio;
		String g;
		Vector<String> goals_at_prio;
		while(it.hasNext()){
			prio=it.next();
			goals_at_prio=new Vector<String>();
			it_goal=gap.get(prio).iterator();
			while(it_goal.hasNext()){
				g=it_goal.next();
				goals_at_prio.add(g);
			}			
			this.put(prio, goals_at_prio);
		}
	}
}
