import java.util.Hashtable;
import java.util.Vector;
import java.util.HashSet;

public class IdManager {
	Hashtable<String,Integer> action_id;
	Hashtable<String,Integer> goal_id;
	Hashtable<String,Integer> conjunction_id;
	Hashtable<String,Integer> trans_id;
	Vector<HashSet<String>> goal_sets;
	
	public IdManager(){
		this.action_id=new Hashtable<String,Integer>();
		this.goal_id=new Hashtable<String, Integer>();
		this.conjunction_id=new Hashtable<String, Integer>();
		this.trans_id=new Hashtable<String, Integer>();
		this.goal_sets=new Vector<HashSet<String>>();
	}
	
	public Integer getActId(String act){
		if(this.action_id.containsKey(act)){
			//System.out.println(this.action_id.get(this.action_id));
			return this.action_id.get(act);	
		}
		Integer new_id=new Integer(this.action_id.keySet().size()+1);
		this.action_id.put(act, new_id);
		return new_id;	
	}

	public Integer getGoalSetId(Vector<String> goal_set){
		boolean dif=true;
		int id=-1;
		for(int iii=0;iii<goal_sets.size()&&dif;iii++){
			if(goal_set.size()==goal_sets.get(iii).size()){
				for(int jjj=0;jjj<goal_set.size() && dif;jjj++){
					if(!goal_sets.get(iii).contains(goal_set.get(jjj))){
						jjj=goal_set.size();
					}else if(jjj==goal_set.size()-1){
						dif=false;
						System.out.println("Found gaols"+iii);
						id=iii;
					}
				}
			}
		}
		if(id==-1){
			HashSet<String> hs=new HashSet<String>();
			hs.addAll(goal_set);
			goal_sets.add(hs);
		}
		return goal_sets.size()-1;	
	}

	public Integer getTransId(String trans){
		if(this.trans_id.containsKey(trans)){
			//System.out.println(this.action_id.get(this.action_id));
			return this.trans_id.get(trans);	
		}
		Integer new_id=new Integer(this.trans_id.keySet().size()+1);
		this.trans_id.put(trans, new_id);
		return new_id;	
	}
	
	public Integer getGoalId(String goal){
		if(this.goal_id.containsKey(goal)){
			//System.out.println(this.action_id.get(this.action_id));
			return this.goal_id.get(goal);	
		}
		Integer new_id=new Integer(this.goal_id.keySet().size()+1);
		this.goal_id.put(goal, new_id);
		return new_id;	
	}

	public Integer getConjunctionId(String conj){
		if(this.conjunction_id.containsKey(conj)){
			//System.out.println(this.action_id.get(this.action_id));
			return this.conjunction_id.get(conj);	
		}
		Integer new_id=new Integer(this.conjunction_id.keySet().size()+1);
		this.conjunction_id.put(conj, new_id);
		return new_id;	
	}
}
